"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  default: () => use_infinite_scroll_default
});
module.exports = __toCommonJS(index_exports);

// src/use-infinite-scroll.ts
var import_react = require("react");
var import_react_intersection_observer_hook = require("react-intersection-observer-hook");
var DEFAULT_DELAY_IN_MS = 100;
function useInfiniteScroll({
  loading,
  hasNextPage,
  onLoadMore,
  rootMargin,
  disabled,
  delayInMs = DEFAULT_DELAY_IN_MS
}) {
  const savedCallbackRef = (0, import_react.useRef)(onLoadMore);
  const [ref, { rootRef, isVisible }] = (0, import_react_intersection_observer_hook.useTrackVisibility)({
    rootMargin
  });
  (0, import_react.useEffect)(() => {
    savedCallbackRef.current = onLoadMore;
  }, [onLoadMore]);
  const shouldLoadMore = !disabled && !loading && isVisible && hasNextPage;
  (0, import_react.useEffect)(() => {
    if (shouldLoadMore) {
      const timer = setTimeout(() => {
        savedCallbackRef.current();
      }, delayInMs);
      return () => {
        clearTimeout(timer);
      };
    }
  }, [shouldLoadMore, delayInMs]);
  return [ref, { rootRef }];
}
var use_infinite_scroll_default = useInfiniteScroll;
